
/*
	DE.java
	Isaac Triguero Velazquez.
	
	Created by Isaac Triguero Velazquez  23-7-2009
	Copyright (c) 2008 __MyCompanyName__. All rights reserved.

*/
package org.sci2s.eamhco;

import java.util.ArrayList;
import java.util.StringTokenizer;
import cec05.benchmark;
import cec05.test_func;






/**
 * @param Population Size.
 * @param Scaling Factor.
 * @param Crossover rate.
 * @param Strategy (1-5).
 * @param MaxIter
 * @author Isaac Triguero Vel�zquez
 * @version 1.0
 */
public class DEGenerator {

  /*Own parameters of the algorithm*/
  
  private int PopulationSize; 
  private int Dimension;
  private int MaxIter; 
  private double ScalingFactor;
  private double CrossOverRate;
  private int Strategy;
  private String CrossoverType; // Binomial, Exponential, Arithmetic
  private long semilla;
  private int MaxEval;
  private int eval;
  private benchmark test;
  private test_func function;
  private double bias;
  private double maxLimit;
  private double minLimit;
  private boolean noBounds = false;
  private int numFuncion;
  
  private double PI = 3.14159265358;
  
  
  /**
   * Build a new DEGenerator Algorithm
   */
  
  public DEGenerator(int poblacion, int dimension, int iteraciones, double F, double CR, int strg, String CrossType,int funcion, long sem)
  {
	  this.PopulationSize = poblacion;
      this.Dimension = dimension;
      this.MaxIter = iteraciones;
      this.ScalingFactor = F;
      this.CrossOverRate = CR;
      this.Strategy = strg;
      this.CrossoverType = CrossType;
      this.numFuncion = funcion;
      this.semilla = sem;
      RandomGenerator.setSeed(this.semilla); // established the seed.
	  test = new benchmark();
	 /* MaxEval = Dimension*10000;
	  eval = 0;
	  function = test.testFunctionFactory(numFuncion, dimension);*/
      
        this.function = test.testFunctionFactory(numFuncion, Dimension);
        bias = function.bias();
        MaxEval = Dimension*10000;
        eval = 0;
        maxLimit = test.get_max_value(numFuncion);
        minLimit = test.get_min_value(numFuncion);
        if(numFuncion == 7 || numFuncion == 25){
                noBounds = true;
        }  }
  

  /*
   * Useful functions
   */
  
  public void inic_vector_sin(int vector[], int without){

  	for(int i=0; i<vector.length; i++) 
  		if(i!=without)
  			vector[i] = i; // Lo inicializo de 1 a n-1
  }


  public void desordenar_vector_sin(int vector[]){
  	int tmp, pos;
  	for(int i=0; i<vector.length-1; i++){
  		pos = RandomGenerator.Randint(0, vector.length-1);
  		tmp = vector[i];
  		vector[i] = vector[pos];
  		vector[pos] = tmp;
  	}
  }
  

  /**
   * Mutant operator
   * @param population
   * @param actual
   * @param mejor
   * @return
   */
  
  
  public Prototype mutant(ArrayList<Prototype> population, int actual, int mejor){
	  
	  
	  Prototype mutant = new Prototype();
	  Prototype r1,r2,r3,r4,r5, resta, producto, resta2, producto2, result, producto3, resta3;
	  
	//We need five different solutions of actual
		   
	  int lista[] = new int[population.size()];
      inic_vector_sin(lista,actual);
      desordenar_vector_sin(lista);
		      
	  // System.out.println("Lista = "+lista[0]+","+ lista[1]+","+lista[2]);
	  
	   r1 = population.get(lista[0]);
	   r2 = population.get(lista[1]);
	   r3 = population.get(lista[2]);
	   r4 = population.get(lista[3]);
	   r5 = population.get(lista[4]);
		
	   double SFi = this.ScalingFactor;
	   
			switch(this.Strategy){
		   	   case 1: // ViG = Xr1,G + F(Xr2,G - Xr3,G) De rand 1
			   		 resta = r2.sub(r3);
			   		 producto = resta.mul(SFi);
			   		 mutant = producto.add(r1);
		   	    break;
			   
		   	case 2: // Vig = Xbest,G + F(Xr2,G - Xr3,G)  De best 1
		   		   
		   		 resta = r2.sub(r3);
		   		 producto = resta.mul(SFi);
		   		 mutant = population.get(mejor).add(producto);
		   break;
		   
	   	   case 3: // Vig = ... De rand to best 1
	   		   resta = r1.sub(r2);
	   		    	resta2 = population.get(mejor).sub(population.get(actual));
	   		 			   		 
	   		    	producto = resta.mul(SFi);
	   		    	producto2 = resta2.mul(SFi);
		   		
		   	   result = population.get(actual).add(producto);
		   	   mutant = result.add(producto2);
		   		 			   		 
		   break;
		   
	   	   case 4: // DE best 2
	   		   resta = r1.sub(r2);
	   		   resta2 = r3.sub(r4);
	   		 			   		 
   		    	producto = resta.mul(SFi);
	   		    	producto2 = resta2.mul(SFi);
		   		
		   	   result = population.get(mejor).add(producto);
		   	   mutant = result.add(producto2);
		   break;
		  
	   	   case 5: //DE rand 2
	   		   resta = r2.sub(r3);
	   		   resta2 = r4.sub(r5);
	   		 			   		 
  		    	producto = resta.mul(SFi);
	   		    	producto2 = resta2.mul(SFi);
		   		
		   	   result = r1.add(producto);
		   	   mutant = result.add(producto2);
		   	   
		       break;
		       
	   	   case 6: //DE rand to best 2
	   		   resta = r1.sub(r2);
	   		   resta2 = r3.sub(r4);
	   		   resta3 =population.get(mejor).sub(population.get(actual)); 
	   		   
  		    	producto = resta.mul(SFi);
	   		    	producto2 = resta2.mul(SFi);
		   	   producto3 = resta3.mul(SFi);
		   	   
		   	   result = population.get(actual).add(producto);
		   	   result = result.add(producto2);
		   	   mutant = result.add(producto3);
		       break;
		       
	   	  /*// Para hacer esta estrat�gia, lo que hay que elegir es CrossoverType = Arithmetic
	   	   * case 7: //DE current to rand 1
	   		   resta = r1.restar(population[actual]); 
	   		   resta2 = r2.restar(r3);
	   		 		   		 
		   	   producto = resta.mulEscalar(RandomGenerator.Randdouble(0, 1));
		   	   producto2 = resta2.mulEscalar(this.ScalingFactor);
		   		
		   	   result = population[actual].sumar(producto);
		   	   mutant = result.sumar(producto2);
		   	   
		       break;
		       */
		   }   
	   

	  // System.out.println("********Mutante**********");
	 // mutant.print();
	   
      mutant.applyThresholds(minLimit, maxLimit);
	
	  return mutant;
  }
  
  
 
  
  /* Code to evaluate rastrigin's function */
  double calc_rastrigin (double x[])
  {
      int i;
      double res;
      res = 0.0;
      for (i=0; i<this.Dimension; i++)
      {
          res += (x[i]*x[i] - 10.0*Math.cos(2.0*this.PI*x[i]) + 10.0);
      }
      return (res-(330)); 
  }
  
  
  /*
   * HERE YOU CAN CHANGE THE FUNCTION: function f9
   */
  
  /**
   * Fitness function.
   */
  double fitness(Prototype p){
	  
	  return function.f(p.getInputs());
	  
  }
  
  
  
  /**
   * Execute the DEGenerator method.
   */
  
  
  public void execute()
  {
	  //System.out.print("\nThe algorithm  DE is starting...\n Computing...\n");
	  
	  	 	    
	  // First, we create the population, with PopulationSize.
	  ArrayList<Prototype> population = new ArrayList<Prototype>();
	  Prototype mutation = new Prototype();
	  Prototype crossover = new Prototype();

	  double fitness[] = new double[PopulationSize];

	  
	  // First Stage, Initialization.
	  
	  for(int i=0; i< PopulationSize; i++){
		  Prototype cromosoma = new Prototype(this.Dimension,1);
		  
		  for(int j=0; j< this.Dimension; j++){
			  cromosoma.setInput(j, RandomGenerator.Randdouble(minLimit, maxLimit));  //Inicialmente aleatorio.
		  }
		  
		  fitness[i]= fitness(cromosoma);
		  eval++;
		//  System.out.println(fitness[i]);
		  population.add(cromosoma);
	  }
	  
	  if(noBounds){
		  maxLimit = Double.MAX_VALUE;
		  minLimit = Double.MIN_VALUE;
	  }
	  
	  
 	  //Find the best initial solution.

	 	  
	  //We select the best initial  particle
	 double bestFitness=fitness[0];
	 int bestFitnessIndex=0;
	
	 for(int i=1; i< PopulationSize;i++){
		  if(fitness[i]<bestFitness){
			  bestFitness = fitness[i];
			  bestFitnessIndex=i;
		  }
		  
	  }
	  
      
	   boolean cruceExp [] = new boolean[PopulationSize];
	   
	   boolean exit = false;
	   for(int iter=0; eval < MaxEval && (Math.abs(bestFitness - bias))> Math.pow(10, -8) && !exit; iter++){ // Main loop
		   
		   
		   // If we are going to use exponential, I calculate the index of possible selecting  Mutation.

		    if(this.CrossoverType.equals("Exponential")){
		     
		       for(int i=0; i<PopulationSize; i++){
					   cruceExp[i] = false;
			   }
		    		    		   
		    }   
			   
			   

		   for(int i=0; i<PopulationSize; i++){
			   		 // Mutation Operation.
				   
				   mutation = new Prototype();
			   
				  //Mutation:
					
				   mutation  = mutant(population, i, bestFitnessIndex);
				   
				    // Crossver Operation.

				   crossover = new Prototype(population.get(i));
				   
				   int j_rand = RandomGenerator.Randint(0, Dimension);
				   
				   for(int j=0; j< (population.get(i)).numberOfInputs(); j++){ // For each part of the solution
					   
					   if(this.CrossoverType.equals("Binomial")){
						   double randNumber = RandomGenerator.Randdouble(0, 1);
						   
						   if(randNumber< this.CrossOverRate || j == j_rand){
							   crossover.setInput(j, mutation.getInput(j)); 
						   }
					   }else if(this.CrossoverType.equals("Exponential")){
						   //int startingPoint = RandomGenerator.Randint(0, PopulationSize);
						   int startingPoint = RandomGenerator.Randint(0, Dimension);
						   
						   int L=0;
						   do{
							   L++;			   
						   }while(RandomGenerator.Randdouble(0, 1)<this.CrossOverRate && (L< population.get(i).numberOfInputs()));
					    
						   for(int m=startingPoint; m< startingPoint+L; m++){
							   crossover.setInput(m%population.get(i).numberOfInputs(), mutation.getInput(j)); // Overwrite
						   }
					   }else if(this.CrossoverType.equals("Arithmetic")){ // Uig = XiG + K*(Vi - Xi)
						   Prototype resta = mutation.sub(population.get(i));
						   crossover = population.get(i).add(resta.mul(RandomGenerator.Randdouble(0, 1)));
					   }else{
						   System.err.println("ERROR, Crossover Type incorrect.");
					   }

					   
					   
				   }

				   
				   
				   // Fourth: Selection Operation.
				   // Decide if the trial vector is better than initial population.
				   //Crossover has the trialVector, we check its fitness.
			       
				  double trialVector = fitness(crossover);
				  eval++;
				   if(eval > MaxEval)
					   exit = true;
				
				  
				  //double trialVector = accuracy(crossover[i],trainingDataSet);
				  //fitness[i] = accuracy(population[i],trainingDataSet);
				  
				  //System.out.println("Trial Vector fitness = "+ trialVector);
				  //System.out.println("fitness de la particula = "+ fitness[i]);
				  
				  if(trialVector < fitness[i]){
					//  System.out.println("Selecting");
					  population.set(i, crossover);
					  fitness[i] = trialVector;
				  }
				   
				  
				  if(fitness[i]<bestFitness){
					  bestFitness = fitness[i];
					  bestFitnessIndex=i;
					  
					 // System.out.println("Iter="+ iter +" Acc= "+ bestFitness); //Useful to show the convergence process.
				  }
				  
				  
			  } //End for (Population Size 
			  
		   

			  
			  
			  
			  
	} //END main loop.

	   //System.out.println("Best -> "+ fitness[bestFitnessIndex]); 
	   System.out.println(semilla + "," + function.name() + "," + function.bias() + ","+
				fitness[bestFitnessIndex] + "," + Math.abs(fitness[bestFitnessIndex]-bias) + "," + eval);

  
} // END execute function.

  
  
  public void leerConfiguracion (String ficheroScript) {

	    String fichero, linea, token;
	    StringTokenizer lineasFichero, tokens;
	    byte line[];
	    int i, j;

	    fichero = Fichero.leeFichero (ficheroScript);
	    lineasFichero = new StringTokenizer (fichero,"\n\r");


	    /*Getting the seed*/
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    semilla = Long.parseLong(tokens.nextToken().substring(1));
		RandomGenerator.setSeed(semilla);
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.PopulationSize = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Dimension = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.MaxIter = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.ScalingFactor = Double.parseDouble(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.CrossOverRate = Double.parseDouble(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.Strategy = Integer.parseInt(tokens.nextToken().substring(1));
	    
	    linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
	    this.CrossoverType = tokens.nextToken().substring(1);
		
		linea = lineasFichero.nextToken();
	    tokens = new StringTokenizer (linea, "=");
	    tokens.nextToken();
		int fun =Integer.parseInt(tokens.nextToken().substring(1));
	    this.function = test.testFunctionFactory(fun, Dimension);
		bias = function.bias();
		MaxEval = Dimension*10000;
		eval = 0;
		maxLimit = test.get_max_value(fun);
		minLimit = test.get_min_value(fun);
		if(fun == 7 || fun == 25){
			noBounds = true;
		}
	    
	  }
  
  
  /**
   * @param args Arguments of the main function.
   */
  public static void main(String[] args)
  {
	
	  //Default values
	  RandomGenerator.setSeed(939393828);
	  int Poblacion=100, dimension=30, iteraciones=500000, estrategia =3, funcion=2;
	  long semilla = 939393828;
	  double F=.5, CR=.5;
	  String CrossType = "Binomial";
	  
	  DEGenerator differential;
	  
	  differential = new DEGenerator(Poblacion,dimension,iteraciones, F,CR,estrategia, CrossType,funcion,semilla);
	  
	  if(args.length == 1){
		differential.leerConfiguracion(args[0]);  
	  }
	  
	  differential.execute();
	  
	  
  }

}